/***********************************************/
/* KeyNX                                   */
/*                   written by shusaku sone   */
/***********************************************/

import com.nttdocomo.device.*;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Display;


public class Key{
	
	//keyFlag    L[ꂽƂL
	//keyDecide: L[ꂽƂ𔻒
	public static long keyFlag;
	public static long keyDecide;
	
	/**
	  *RXgN^
	  */
	void key(){
		keyFlag=0;
		keyDecide=0;
	}
	
	/**
	  * L[̏ԂێĂ
	  */
	public static int keyState(){
		
		int state=0;
		if(isKeyPressed(Display.KEY_UP)){
			state=Display.KEY_UP;
		}else if(isKeyPressed(Display.KEY_UPPER_LEFT)){
			state=Display.KEY_UPPER_LEFT;
		}else if(isKeyPressed(Display.KEY_UPPER_RIGHT)){
			state=Display.KEY_UPPER_RIGHT;
		}else if(isKeyPressed(Display.KEY_RIGHT)){
			state=Display.KEY_RIGHT;
		}else if(isKeyPressed(Display.KEY_LEFT)){
			state=Display.KEY_LEFT;
		}else if(isKeyPressed(Display.KEY_LOWER_LEFT)){
			state=Display.KEY_LOWER_LEFT;
		}else if(isKeyPressed(Display.KEY_LOWER_RIGHT)){
			state=Display.KEY_LOWER_RIGHT;
		}else if(isKeyPressed(Display.KEY_DOWN)){
			state=Display.KEY_DOWN;
		}else if(isKeyPressed(Display.KEY_SELECT)){
			state=Display.KEY_SELECT;
		}
		return state;
	}
	
	/**
	  * L[ꂽƂ`FbN
	  */
	public static boolean isKeyPressedCheck() {
		if(isKeyPressed(Display.KEY_LEFT)
		||isKeyPressed(Display.KEY_RIGHT)
		||isKeyPressed(Display.KEY_UP)
		||isKeyPressed(Display.KEY_DOWN)
		||isKeyReleased(Display.KEY_UPPER_LEFT)
		||isKeyReleased(Display.KEY_UPPER_RIGHT)
		||isKeyReleased(Display.KEY_LOWER_LEFT)
		||isKeyReleased(Display.KEY_LOWER_RIGHT)
		||isKeyReleased(Display.KEY_SELECT)
		){
			return true;
		}
		return false;
	}
	
	/**
	  * L[[XꂽƂ`FbN
	  */
	public static boolean isKeyReleasedCheck(){
		if(isKeyReleased(Display.KEY_LEFT)
		&&isKeyReleased(Display.KEY_RIGHT)
		&&isKeyReleased(Display.KEY_UP)
		&&isKeyReleased(Display.KEY_DOWN)
		&&isKeyReleased(Display.KEY_UPPER_LEFT)
		&&isKeyReleased(Display.KEY_UPPER_RIGHT)
		&&isKeyReleased(Display.KEY_LOWER_LEFT)
		&&isKeyReleased(Display.KEY_LOWER_RIGHT)
		&&isKeyReleased(Display.KEY_SELECT)		
		){
			return true;
		}
		return false;
	}
	
    /**
	  * L[f
	  * @param key - L[R[h
	  */
	public static boolean isKeyPressed(int key) {
		if ((keyDecide & (1L << key)) != 0) {
			return true;
		}
		return false;
	}
	
	/**
	  * L[[Xf
	  * @param key - L[R[h
	  */
	public static boolean isKeyReleased(int key){
		if ((keyDecide & (1L << key)) == 0) {
			return true;
		}
		return false;
	}
	
	/**
	  * L[o^܂
	  */
	public static void registKeyEvent() {
		keyDecide = keyFlag;
	}
	
}